<!doctype html>
<html>
  <body>
  <h2>La gestion des ressources</h2>
  <p>Dans un projet <i>Android</i>, le dossier <code>res/</code> est consacré aux
  ressources.<br>
  Les éléments considérés comme  étant une ressource sont :<br>
  <ul>
    <li>une interface graphique : située dans le dossier <code>layout/</code></li>
    <li>une image :  située dans le dossier<code>drawable/</code> (ou
      <code>mipmap/</code> pour les icônes de haute résolution)</li>
    <li>un texte : généralement situé dans le fichier <code>strings.xml</code> du dossier <code>values/</code></li>
    <li>une couleur : située dans le fichier <code>colors.xml</code> du dossier <code>values/</code></li>
    <li>une dimension : située dans le fichier <code>dimens.xml</code> du dossier <code>values/</code></li>
    <li>un style d'un élément graphique : située dans le fichier <code>styles.xml</code> du dossier <code>values/</code></li>
    <li>un élément d'un menu natif : située dans un fichier <code>.xml</code> du dossier <code>menu/</code></li>
    <li>un fichier audio : situé dans le dossier <code>raw/</code></li>
    <li>etc.</li>
  </ul>
  </p>

  <h3>L'externalisation</h3>
  <p>L'intérêt d'un dossier dédiés aux «ressources» est d'externaliser les
  développements. Par exemple, la couleur principale de l'application est stockée
  dans une variable des ressources. De cette façon, si l'on souhaite modifier
  la teinte de cette dernière alors il suffira de modifier la valeur de cette variable
  et cela prendra effet dans toute l'application (modifier à un seul endroit
  pour changer partout). Ce principe garantie l'homogénéité de l'interface.</p>

  <h3>L'internationalisation</h3>
  <p>La spécificité de ce dossier <code>res/</code> est de gérer l'internationalisation.<br>
  Le fonctionnement est de placer la ressource concernée par la langue dans
  le dossier dont l'extension correspond à la langue (ex : <code>values-fr</code>,
  <code>drawable-es</code>).<br>
 Concrêtement, les traductions françaises sont situés dans le fichier <code>strings.xml</code>
 du dossier <code>values-fr/</code>.<br>
Le système <i>Android</i> gère automatiquement d'afficher le texte français
lorsque le téléphone de l'utilisateur est paramétré en français.<br>
Remarque : La gestion de l'internationalisation est l'une des différences entre
le développement web et le développement sur mobile.<br></p>

<h3>La plasticité de l'interface</h3>
<p>Des extensions spécifiques accolées aux dossiers des ressources permettent l'adaptation de l'interface graphique
  aux différentes tailles d'écran et au format de l'écran (mode paysage ou portrait)</p>
<p>Concernant l'adaptation à la taille de l'écran, on distingue les écrans de type
<i>smartphone</i> et ceux de type <i>tablette<i>. Par exemple, les dimensions d'un
  bouton pour tablette est contenu dans une variable du fichier <code>dimens.xml</code>,
  contenu dans <code>values-large/</code>.</p>
  <p>Le lien suivant contient une liste exhaustive des fichiers de ressources, leurs extensions,
    ainsi que les caractéristiques attendues des ressources : <br>
<a href="https://developer.android.com/guide/topics/resources/providing-resources.html">
  Developer Android: Providing resources</a></p>
  <h4>Partie suivante</h4>
  <a href="file:///android_asset/4-lesmenus.html">Les menus</a>
  </body>
</html>
